package app;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.List;

import kernel.Cell;
import kernel.Grid;

public class ApplicationDeserialization {
	public static void main(String[] args) throws IOException, ClassNotFoundException {
		File fichier =  new File("essai.ser") ;

		 // ouverture d'un flux sur un fichier
		ObjectInputStream ois =  new ObjectInputStream(new FileInputStream(fichier)) ;
				
		 // désérialization de l'objet
		Grid grid = (Grid)ois.readObject() ;
		// Affichage
        List<Cell> cells = grid.getCells();

        System.out.println("Affichage des valeurs :");
        for (Cell cell : cells)
            System.out.println(cell.getId() + ": " + cell.getValue());

        System.out.println("Affichage des formules :");
        for (Cell cell : cells)
            System.out.println(cell.getId() + ": " + cell.toString());

        System.out.println("Affichage des formules développées :");
        for (Cell cell : cells)
            System.out.println(cell.getId() + ": " + cell.getDevelopedFormula());
		ois.close();
	}

}
